import { ClassType } from '@deepkit/core';
import { Database, OrmEntity, Query } from '@deepkit/orm';
import { IGridRequestDto } from './GridRequestDto';
import GridResponse from './GridResponse';
export default abstract class AGrid<T extends OrmEntity> {
    private readonly db;
    protected abstract entity: ClassType;
    protected filterableColumns: Record<string, string> | null;
    protected sortableColumns: Record<string, string> | null;
    protected searchableColumns: string[] | null;
    constructor(db: Database);
    filter(dto: IGridRequestDto): Promise<GridResponse<T>>;
    protected searchQuery(query: Query<T>): Query<T>;
    private static isFilterEmpty;
    private static createExpression;
    private addPaging;
    private addSorter;
    private addFilter;
    private getFilterableColumn;
}
