import { Knex } from 'knex';
import { Direction, IGridRequestDto, Operator } from './GridRequestDto';
import GridResponse from './GridResponse';
export type ICallbackFilter = (queryBuilder: Knex.QueryBuilder, column: string, operator: Operator, values: string[]) => Knex.QueryBuilder;
export type ICallbackSorter = (queryBuilder: Knex.QueryBuilder, column: string, direction: Direction) => Knex.QueryBuilder;
export default abstract class AKnexGrid<T> {
    private readonly knex;
    protected filterableColumns: Record<string, ICallbackFilter | string> | null;
    protected sortableColumns: Record<string, ICallbackSorter | string> | null;
    protected searchableColumns: string[] | null;
    constructor(knex: Knex);
    protected abstract searchQuery(knex: Knex, dto: IGridRequestDto): any;
    protected abstract toObject(data: Record<string, unknown>): T;
    filter(dto: IGridRequestDto): Promise<GridResponse<T>>;
    protected countQuery(knex: Knex): Promise<any>;
    private static addOrExpression;
    private addPaging;
    private addSorters;
    private addFilters;
    private getFilterableColumn;
}
export declare type __ΩICallbackFilter = any[];
export declare type __ΩICallbackSorter = any[];
