import { BaseEntity, DataSource, ObjectType, Repository, SelectQueryBuilder, WhereExpressionBuilder } from 'typeorm';
import { Direction, IGridRequestDto, Operator } from './GridRequestDto';
import GridResponse from './GridResponse';
export type ICallbackFilter = (queryBuilder: WhereExpressionBuilder, operator: Operator, values: string[]) => void;
export type ICallbackSorter = <T extends BaseEntity>(queryBuilder: SelectQueryBuilder<T>, direction: Direction) => void;
export default abstract class ATypeORMGrid<T extends BaseEntity> {
    private readonly dataSource;
    constructor(dataSource: DataSource);
    protected abstract getEntity(): ObjectType<T>;
    protected abstract getQueryBuilder(repository: Repository<T>): SelectQueryBuilder<T>;
    protected abstract getFilters(): Record<string, ICallbackFilter | string>;
    protected abstract getSorters(): Record<string, ICallbackSorter | string>;
    protected abstract getSearches(): string[];
    filter(dto: IGridRequestDto): Promise<GridResponse<T>>;
    protected addOrExpression(queryBuilder: WhereExpressionBuilder, column: string, operator: Operator, values: string[]): void;
    private getFilterColumn;
    private getSorterColumn;
    private addFilters;
    private addSorters;
    private addFilter;
    private addPaging;
}
export declare type __ΩICallbackFilter = any[];
export declare type __ΩICallbackSorter = any[];
