"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const { __ΩICallbackFilter } = require('../lib/AKnexGrid');
const { __ΩICallbackSorter } = require('../lib/AKnexGrid');
const { __ΩIGridRequestDto } = require('../lib/GridRequestDto');
function __assignType(fn, args) {
    fn.__type = args;
    return fn;
}
const __ΩRecord = ['K', 'T', 'l\'e#"Rb!b"Pde"!N#!'];
const AKnexGrid_1 = __importDefault(require("../lib/AKnexGrid"));
const GridItem_1 = __importDefault(require("./GridItem"));
class ExampleGrid extends AKnexGrid_1.default {
    filterableColumns = {
        id: 'e.id',
        namae: 'e.name',
        losos: 'l.id',
        callback: __assignType((queryBuilder, column, operator, values) => queryBuilder.andWhere('e.id', operator, values), ['queryBuilder', 'column', 'operator', 'values', '', 'P"2!"2""2#"2$"/%']),
    };
    sortableColumns = {
        id: 'e.id',
        losos: 'l.id',
        callback: __assignType((queryBuilder, column, direction) => queryBuilder.orderBy('e.id', direction), ['queryBuilder', 'column', 'direction', '', 'P"2!"2""2#"/$']),
    };
    searchableColumns = [
        'id',
        'namae',
    ];
    searchQuery(knex, dto) {
        return knex
            .from('example as e')
            .leftJoin('losos as l', 'e.lososId', '=', 'l.id')
            .select('e.id as id', 'e.name as name', 'l.name as losos');
    }
    toObject(data) {
        return GridItem_1.default.fromRaw(data);
    }
    static __type = [() => GridItem_1.default, () => AKnexGrid_1.default, () => __ΩRecord, () => __ΩICallbackFilter, 'filterableColumns', function () { return {
            id: 'e.id',
            namae: 'e.name',
            losos: 'l.id',
            callback: __assignType((queryBuilder, column, operator, values) => queryBuilder.andWhere('e.id', operator, values), ['queryBuilder', 'column', 'operator', 'values', '', 'P"2!"2""2#"2$"/%']),
        }; }, () => __ΩRecord, () => __ΩICallbackSorter, 'sortableColumns', function () { return {
            id: 'e.id',
            losos: 'l.id',
            callback: __assignType((queryBuilder, column, direction) => queryBuilder.orderBy('e.id', direction), ['queryBuilder', 'column', 'direction', '', 'P"2!"2""2#"/$']),
        }; }, 'searchableColumns', function () { return [
            'id',
            'namae',
        ]; }, 'knex', () => __ΩIGridRequestDto, 'dto', 'searchQuery', () => __ΩRecord, 'data', () => GridItem_1.default, 'toObject', () => GridItem_1.default, 'PP7!7"P&Pn$&Jo##,J3%<>&P&Pn(&Jo\'#,J3)<>*P&F,J3+<>,P"2-n.2/"00<P&#o1#22P7304<5P756"'];
}
exports.default = ExampleGrid;
