"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const { __ΩICallbackFilter } = require('../../lib/ATypeORMGrid');
const { __ΩICallbackSorter } = require('../../lib/ATypeORMGrid');
function __assignType(fn, args) {
    fn.__type = args;
    return fn;
}
const __ΩRecord = ['K', 'T', 'l\'e#"Rb!b"Pde"!N#!'];
const typeorm_1 = require("typeorm");
const ATypeORMGrid_1 = __importDefault(require("../../lib/ATypeORMGrid"));
const Item_1 = __importDefault(require("./Item"));
class Grid extends ATypeORMGrid_1.default {
    getEntity() {
        return Item_1.default;
    }
    getQueryBuilder(repository) {
        return repository
            .createQueryBuilder('i')
            .leftJoinAndSelect('i.category', 'c')
            .leftJoinAndSelect('i.tags', 't');
    }
    getFilters() {
        return {
            itemId: 'i.id',
            itemName: 'i.name',
            itemDescription: 'i.description',
            categoryName: 'c.name',
            categoryDescription: 'c.description',
            tagName: 't.name',
            tagDescription: 't.description',
            namesAndDescriptions: __assignType((queryBuilder, operator, values) => {
                this.addOrExpression(queryBuilder, 'CONCAT(i.name, i.description, c.name, c.description, t.name, t.description)', operator, values);
            }, ['queryBuilder', 'operator', 'values', '', 'P"2!"2""2#"/$']),
        };
    }
    getSorters() {
        return {
            itemId: 'i.id',
            itemName: 'i.name',
            itemDescription: 'i.description',
            categoryName: 'c.name',
            categoryDescription: 'c.description',
            tagName: 't.name',
            tagDescription: 't.description',
            namesAndDescriptions: __assignType((queryBuilder, direction) => {
                queryBuilder
                    .addOrderBy('i.name', direction)
                    .addOrderBy('i.description', direction)
                    .addOrderBy('c.name', direction)
                    .addOrderBy('c.description', direction)
                    .addOrderBy('t.name', direction)
                    .addOrderBy('t.description', direction);
            }, ['queryBuilder', 'direction', '', 'P"2!"2""/#']),
        };
    }
    getSearches() {
        return [
            'itemName',
            'itemDescription',
            'categoryName',
            'categoryDescription',
            'tagName',
            'tagDescription',
            'namesAndDescriptions',
        ];
    }
    static __type = [() => Item_1.default, () => ATypeORMGrid_1.default, 'getEntity', () => Item_1.default, () => typeorm_1.Repository, 'repository', () => Item_1.default, () => typeorm_1.SelectQueryBuilder, 'getQueryBuilder', () => __ΩRecord, () => __ΩICallbackFilter, 'getFilters', () => __ΩRecord, () => __ΩICallbackSorter, 'getSorters', 'getSearches', () => Item_1.default, 'PP7!7"P"0#<PPP7$7%2&PP7\'7(0)<P&Pn+&Jo*#0,<P&Pn.&Jo-#0/<P&F00<5P716"'];
}
exports.default = Grid;
